package probe

import (
	"context"
	"encoding/json"

	cwf "git.loafle.net/commons_go/websocket_fasthttp"
	oocmp "git.loafle.net/overflow/overflow_commons_go/modules/probe"
	probeM "git.loafle.net/overflow/overflow_commons_go/modules/probe/model"
	oogweg "git.loafle.net/overflow/overflow_gateway_websocket/external/grpc"
	"git.loafle.net/overflow/overflow_gateway_websocket/rpc"
	// jwt "github.com/dgrijalva/jwt-go"
	"github.com/valyala/fasthttp"
)

func newGatewayRPCHandler() rpc.GatewayRPCHandler {
	gh := &GatewayRPCHandlers{}

	return gh
}

type GatewayRPCHandlers struct {
	rpc.GatewayRPCHandlers
}

func (sh *GatewayRPCHandlers) Init(serverCTX cwf.ServerContext) error {
	return nil
}

func (sh *GatewayRPCHandlers) Handshake(socketCTX cwf.SocketContext, ctx *fasthttp.RequestCtx) (id string, extensionsHeader *fasthttp.ResponseHeader) {
	bMethod := ctx.Request.Header.Peek(oocmp.HTTPRequestHeaderKey_Probe_Method)
	if nil == bMethod {
		return "", nil
	}
	method := string(bMethod)

	switch method {
	case oocmp.HTTPRequestHeaderValue_Probe_Method_Connect:
	default:
		return "", nil
	}

	// var ok bool
	// // tokenString := string(soc.Conn().Headers().Cookie("AuthToken"))
	// tokenString := "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzUxMiJ9.eyJpc3MiOiJvdmVyRmxvdyIsImlhdCI6MTUwNDU5NTExOSwiZXhwIjoxNTM2MTMxMTE5LCJhdWQiOiJ3d3cub3ZlcmZsb3cuY2xvdWQiLCJzdWIiOiJvdmVyZmxvd0Bsb2FmbGUuY29tIn0.-WQi3OykPlJ9x8RcZGhWXEtGw4GhU6wmyJ_AWh2rMeUatQylfPzvmum2Xfp6pwKLMmcP76XoDPNyq06i7RKWNQ"
	// token, err := jwt.Parse(tokenString, func(token *jwt.Token) (interface{}, error) {
	// 	// Don't forget to validate the alg is what you expect:
	// 	if _, ok := token.Method.(*jwt.SigningMethodHMAC); !ok {
	// 		return nil, fmt.Errorf("Webapp: Unexpected signing method: %v", token.Header["alg"])
	// 	}

	// 	// hmacSampleSecret is a []byte containing your secret, e.g. []byte("my_secret_key")
	// 	return []byte(config.Config.Auth.SigningKey), nil
	// })

	// if nil != err {
	// 	return "", nil
	// }

	// var claims jwt.MapClaims
	// if claims, ok = token.Claims.(jwt.MapClaims); !ok || !token.Valid {
	// 	logging.Logger().Warn(fmt.Sprintf("Webapp: Token is not valid %v", token))
	// 	return "", nil
	// }
	bProbeKey := ctx.Request.Header.Peek(oocmp.HTTPRequestHeaderKey_Probe_ProbeKey)
	if nil == bProbeKey {
		return "", nil
	}
	probeKey := string(bProbeKey)

	grpcCTX := context.Background()
	r, err := oogweg.Exec(grpcCTX, "ProbeService.readByProbeKey", []string{probeKey})
	if nil != err {
		return "", nil
	}
	probe := &probeM.Probe{}
	err = json.Unmarshal([]byte(r), probe)
	if nil != err {
		return "", nil
	}

	extensionsHeader = &fasthttp.ResponseHeader{}
	extensionsHeader.Add(oocmp.HTTPResponseHeaderKey_Probe_SetEncryptionKey, probe.EncryptionKey)

	return probeKey, extensionsHeader
}

func (sh *GatewayRPCHandlers) Validate() {
	sh.GatewayRPCHandlers.Validate()
}
